#ifndef PACKAGE_MAIL_POSTERITY_FMT0_H
#define PACKAGE_MAIL_POSTERITY_FMT0_H

#include <skalibs/stddjb.h>
#include "prjlibs-c/intattr.h"
#include "prjlibs-c/types.h"

#define FMT0_BUF_LEN(type) (INTATTR_LEN(10, type)+1)
#define FMT0(type, buffer, value) \
  (WARN_PTYPE(char (**)[FMT0_BUF_LEN(type)], (buffer)), \
   fmt0(*((char (*)[FMT0_BUF_LEN(type)])(buffer)), \
        WARN_CAST(type, (value))))
extern type_len fmt0(char*, uint64);

#define FMT0_BUF(type, name) char name[FMT0_BUF_LEN(type)]
typedef FMT0_BUF(uint32, type_uint32_buf);
typedef FMT0_BUF(uint64, type_uint64_buf);

#endif
