#include "prjlibs-c/standards.h"
#include <string.h>
#include <stdlib.h>

#include <skalibs/stddjb.h>
#include "prjlibs-c/constants.h"
#include "prjlibs-c/diewarn.h"
#include "prjlibs-c/vec.h"
#include "get_addr.h"

char const* get_addr(void) {
  VEC_T(char) v=VEC_0(char);
  char const* var=getenv("PROTO");
  if (var==NULLP) return "";
  if (VEC_PUSHS(&v, var, 1)!=0 || VEC_PUSHA(char, &v, "REMOTEIP", 0)!=0)
    DIE0(alloc);
  var=getenv(VEC_ELTS(char, &v));
  VEC_FREE(char, &v);
  if (var==NULLP) return "";
  return var;
}
