#include "prjlibs-c/standards.h"
#include <unistd.h>

#include <skalibs/stddjb.h>
#include "prjlibs-c/standards.h"
#include "prjlibs-c/diewarn.h"
#include "read_line.h"

type_bool read_line(vec_type* v) {
  type_bool cr;
  for (;;) {
    char ch;
    switch (buffer_get(buffer_0, &ch, 1)) {
      case 0: _exit(0);
      case 1: break;
      default: DIE1(read, "network");
    }
    if (ch=='\n') break;
    if (vec_insn(sizeof (char), v, v->len, &ch, 1)!=0) DIE0(alloc);
  }
  cr=(v->len>0 && v->s[v->len-1]=='\r');
  if (cr) --v->len;
  return cr;
}
