#include "prjlibs-c/standards.h"
#include <stddef.h>

#include "prjlibs-c/vec.h"
#include "types.h"
#include "uil.h"

size_t uil_index(type_uil const* uil, type_uid uid) {
  size_t i, n;
  size_t const          len =VEC_LEN (type_uid, uil);
  type_uid const* const elts=VEC_ELTS(type_uid, uil);
  uid--;
  for (n=0, i=0; i!=len; i+=2) {
    if (uid<elts[i]) return -1;
    if (uid<elts[i+1]) return n+(size_t)(uid-elts[i]);
    n+=(size_t)(elts[i+1]-elts[i]);
  }
  return -1;
}
