#include "prjlibs-c/standards.h"
#include <stddef.h>

#include "prjlibs-c/vec.h"
#include "prjlibs-c/types.h"
#include "types.h"
#include "uil.h"

void uil_iter_init(type_uil_iter* iter, type_uil const* uil) {
  iter->elt=0;
  iter->uil=uil;
}

type_bool uil_iter_next(type_uil_iter* iter) {
  size_t const          len =VEC_LEN (type_uid, iter->uil);
  type_uid const* const elts=VEC_ELTS(type_uid, iter->uil);
  if (iter->elt==0) {
    if (len==0) return 0;
    iter->i=0;
    iter->elt=elts[0]+1;
    return 1;
  }
  if (iter->elt<elts[iter->i+1]) {
    iter->elt++;
    return 1;
  }
  iter->i+=2;
  if (iter->i==len) return 0;
  iter->elt=elts[iter->i]+1;
  return 1;
}
