#include "prjlibs-c/standards.h"
#include <sys/time.h>

#include <skalibs/stddjb.h>
#include "prjlibs-c/types.h"
#include "prjlibs-c/vec.h"
#include "prjlibs-c/constants.h"
#include "types.h"
#include "must.h"
#include "get_unique_id.h"

void get_unique_id(str* id) {
  struct timeval tv;
  stralloc hostname=GENALLOC_ZERO;
  type_uint64_buf buf;

  gettimeofday(&tv, NULLP);
  if (sagethostname(&hostname)!=0) DIE0(alloc);

  VEC_TRUNC(char, id, 0);
  must_n(id, buf, uint64_fmt(buf, tv.tv_sec));
  must_a(id, ".M", 1);
  must_n(id, buf, uint64_fmt(buf, tv.tv_usec));
  must_1(id, 'P');
  must_n(id, buf, uint64_fmt(buf, getpid()));
  must_1(id, '.');
  must_n(id, hostname.s, hostname.len);
}
