

type_status read_sp_astring(str* astring, type_bool flag_accept_wild) {
  VEC_TRUNC(char, astring, 0);
  if (!consumec(' ')) return -1;
  if (consumec('{')) {
    type_len end=0, len, len_read=0;
    type_status r;
    for (;;) {
      end+=byte_chr(b0peek+end, b0len-end, '}');
      if (end<b0len) break;
      b0fillx();
    }
    if (end==0 || scan_len(b0peek, &len)!=end) return -1;
    consumec('\r');
    if (!consumec('\n')) return -1;
    must_alloc(astring, len);
    RESPOND_CONT_0();
    r=buffer_getall(buffer_0, s(astring), len, &len_read);
    if (r<0) DIE1(read, src_stdin);
    if (r==0) _exit(0);
  } else if (consumec('"')) {
    for (;;) {
      type_len qstrlen;
      qstrlen=byte_in(b0peek, b0len, "\"\\\n", 3);
      must_n(astring, b0peek, qstrlen);
      b0seek(qstrlen);
      if (buffer_isempty(buffer_0)) { b0fillx(); continue; }
      if (consumec('"')) break;
      if (!consumec('\\')) return -1;
      fill_if_empty_0();
      must_n(astring, b0peek, 1);
      b0seek(1);
    }
  } else {
    do {
      type_len atomlen;
      for (atomlen=0;; ++atomlen) {
        char ch;
        if (atomlen==b0len) {
          if (buffer_isfull(buffer_0)) break;
          b0fillx();
        }
        ch=b0peek[atomlen];
        if (ch<0x20 || ch>=0x7f || ch=='(' || ch==')' || ch=='{' ||
            ch==' ' || ch=='\\' || ch=='"' ||
            (!flag_accept_wild && (ch=='%' || ch=='*')))
          break;
      }
      must_n(astring, b0peek, atomlen);
      b0seek(atomlen);
    } while (buffer_isempty(buffer_0));
    if (l(astring)==0) return -1;
  }
  return 0;
}
