#include "prjlibs-c/standards.h"
#include <stddef.h>

#include "prjlibs-c/vec.h"
#include "types.h"
#include "uil.h"

type_uid uil_ct(type_uil const* uil) {
  type_uid ct;
  size_t i;
  size_t const          len =VEC_LEN (type_uid, uil);
  type_uid const* const elts=VEC_ELTS(type_uid, uil);
  for (ct=0, i=0; i!=len; i+=2) ct+=elts[i+1]-elts[i];
  return ct;
}
